/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TImportLog.TImportLogPath;
import de.ship.db.tables.records.TImportLogRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TImportLog extends TableImpl<TImportLogRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_import_log</code>
     */
    public static final TImportLog T_IMPORT_LOG = new TImportLog();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TImportLogRecord> getRecordType() {
        return TImportLogRecord.class;
    }

    /**
     * The column <code>common_dd.t_import_log.lastchange</code>.
     */
    public final TableField<TImportLogRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_import_log.pk</code>. the used id, act as
     * primary key
     */
    public final TableField<TImportLogRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "the used id, act as primary key");

    /**
     * The column <code>common_dd.t_import_log.fk_import_log</code>. the id from
     * parent
     */
    public final TableField<TImportLogRecord, Integer> FK_IMPORT_LOG = createField(DSL.name("fk_import_log"), SQLDataType.INTEGER, this, "the id from parent");

    /**
     * The column <code>common_dd.t_import_log.pseudo_id</code>. the proband
     * pseudo id
     */
    public final TableField<TImportLogRecord, String> PSEUDO_ID = createField(DSL.name("pseudo_id"), SQLDataType.CLOB.nullable(false), this, "the proband pseudo id");

    /**
     * The column <code>common_dd.t_import_log.measure_id</code>. the measure
     * id, if known
     */
    public final TableField<TImportLogRecord, Integer> MEASURE_ID = createField(DSL.name("measure_id"), SQLDataType.INTEGER, this, "the measure id, if known");

    /**
     * The column <code>common_dd.t_import_log.import_date</code>. date of
     * import
     */
    public final TableField<TImportLogRecord, LocalDateTime> IMPORT_DATE = createField(DSL.name("import_date"), SQLDataType.LOCALDATETIME(6).nullable(false), this, "date of import");

    /**
     * The column <code>common_dd.t_import_log.state</code>. import state of
     * import item
     */
    public final TableField<TImportLogRecord, Integer> STATE = createField(DSL.name("state"), SQLDataType.INTEGER.nullable(false), this, "import state of import item");

    /**
     * The column <code>common_dd.t_import_log.description</code>. further
     * description of import item
     */
    public final TableField<TImportLogRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB, this, "further description of import item");

    private TImportLog(Name alias, Table<TImportLogRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TImportLog(Name alias, Table<TImportLogRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_import_log</code> table reference
     */
    public TImportLog(String alias) {
        this(DSL.name(alias), T_IMPORT_LOG);
    }

    /**
     * Create an aliased <code>common_dd.t_import_log</code> table reference
     */
    public TImportLog(Name alias) {
        this(alias, T_IMPORT_LOG);
    }

    /**
     * Create a <code>common_dd.t_import_log</code> table reference
     */
    public TImportLog() {
        this(DSL.name("t_import_log"), null);
    }

    public <O extends Record> TImportLog(Table<O> path, ForeignKey<O, TImportLogRecord> childPath, InverseForeignKey<O, TImportLogRecord> parentPath) {
        super(path, childPath, parentPath, T_IMPORT_LOG);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TImportLogPath extends TImportLog implements Path<TImportLogRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TImportLogPath(Table<O> path, ForeignKey<O, TImportLogRecord> childPath, InverseForeignKey<O, TImportLogRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TImportLogPath(Name alias, Table<TImportLogRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TImportLogPath as(String alias) {
            return new TImportLogPath(DSL.name(alias), this);
        }

        @Override
        public TImportLogPath as(Name alias) {
            return new TImportLogPath(alias, this);
        }

        @Override
        public TImportLogPath as(Table<?> alias) {
            return new TImportLogPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TImportLogRecord, Integer> getIdentity() {
        return (Identity<TImportLogRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TImportLogRecord> getPrimaryKey() {
        return Keys.PK_IMPORT_LOG;
    }

    @Override
    public List<ForeignKey<TImportLogRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_IMPORT_LOG__FK_IMPORT_LOG);
    }

    private transient TImportLogPath _tImportLog;

    /**
     * Get the implicit join path to the <code>common_dd.t_import_log</code>
     * table.
     */
    public TImportLogPath tImportLog() {
        if (_tImportLog == null)
            _tImportLog = new TImportLogPath(this, Keys.T_IMPORT_LOG__FK_IMPORT_LOG, null);

        return _tImportLog;
    }

    @Override
    public TImportLog as(String alias) {
        return new TImportLog(DSL.name(alias), this);
    }

    @Override
    public TImportLog as(Name alias) {
        return new TImportLog(alias, this);
    }

    @Override
    public TImportLog as(Table<?> alias) {
        return new TImportLog(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportLog rename(String name) {
        return new TImportLog(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportLog rename(Name name) {
        return new TImportLog(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportLog rename(Table<?> name) {
        return new TImportLog(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportLog where(Condition condition) {
        return new TImportLog(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportLog where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportLog where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportLog where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportLog where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportLog where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportLog where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportLog where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportLog whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportLog whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
